# Hunter's Hostage Skins Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/hostage_skins/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load hostage_skins
#
################################################################################
#import EventScripts
import es
#import Libraries
import gamethread
import os
import random
#import Psyco Compiler
import psyco
psyco.full()

# Addon Information
info = es.AddonInfo()
info.name = "Hostage Skins"
info.version = "2.0.0"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "Randomizes Hostage Skins"
info.basename = "hostage_skins"

hunter_hostage_skins_ver    = info.version
hunter_hostage_skins_text   = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.247+ (Python Version)'

# Server Variables
hostage_skins_download      = es.ServerVar('hostage_skins_download', '1', 'Should the files be downloaded with EventScripts?')

# Global Variables
hostage_skins_downloadables = []
hostage_skins_skins         = []
hostage_skins_hostages      = {}
hostage_skins_sounds        = {
                               'hpain':['hpain/hpain1.wav', 'hpain/hpain2.wav', 'hpain/hpain3.wav', 'hpain/hpain4.wav', 'hpain/hpain5.wav', 'hpain/hpain6.wav'],
                               'hunuse':['hunuse/comeback.wav', 'hunuse/dontleaveme.wav', 'hunuse/illstayhere.wav', 'hunuse/notleaveme.wav', 'hunuse/yeahillstay.wav'],
                               'huse':['huse/getouttahere.wav', 'huse/illfollow.wav', 'huse/letsdoit.wav', 'huse/letsgo.wav', 'huse/letshurry.wav', 'huse/letsmove.wav', 'huse/okletsgo.wav', 'huse/youlead.wav']
                              }

def load():
    public = es.ServerVar('hu_ho', info.version, info.name)
    public.makepublic()
    
    es.regcmd('hostage_skins_addskin', 'hostage_skins/addskin', 'Add a skin and soundpath to Hostage Skins')
    es.regcmd('hostage_skins_adddownload', 'hostage_skins/adddownload', 'Add files to Hostage Skins auto-download')
    
    es.log(hunter_hostage_skins_text)
    es.msg('#multi', '#green[HostageSkins] #defaultLoaded')
    
def unload():
    es.msg('#multi', '#green[HostageSkins] #defaultUnloaded') 

def es_map_start(event_var):
    if int(hostage_skins_download):
        for filename in hostage_skins_downloadables:
            es.stringtable('downloadables', filename)
    for skin in hostage_skins_skins:
        es.precachemodel(_mdlstr(skin['model']))

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_hostage_skins_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_hostage_skins_text)

def player_activate(event_var):
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_hostage_skins_text))

def round_start(event_var):
    if len(hostage_skins_skins) > 0:
        for hostage in es.createentitylist('hostage_entity'):
            skinid = random.randint(0, len(hostage_skins_skins)-1)
            model = _mdlstr(hostage_skins_skins[skinid]['model'])
            soundpath = hostage_skins_skins[skinid]['soundpath']
            hostage_skins_hostages[hostage] = hostage_skins_skins[skinid]
            es.setindexprop(hostage, 'CBaseEntity.m_nModelIndex', es.precachemodel(model))
            userid = int(es.getuserid())
            if userid > 0:
                es.server.cmd('es_xfire '+str(userid)+' hostage_entity color "255 255 255"')
                
def hostage_hurt(event_var):
    hostage = int(event_var['hostage'])
    if hostage in hostage_skins_hostages:
        _playsound(hostage, 'hpain')
        
def hostage_stops_following(event_var):
    hostage = int(event_var['hostage'])
    if hostage in hostage_skins_hostages:
        _playsound(hostage, 'hunuse')

def hostage_follows(event_var):
    hostage = int(event_var['hostage'])
    if hostage in hostage_skins_hostages:
        _playsound(hostage, 'huse')

def addskin():
    if int(es.getargc()) >= 2:
        skin = {'model':es.getargv(1), 'soundpath':es.getargv(2)}
        hostage_skins_skins.append(skin)
    else:
        es.dbgmsg(0, 'Syntax: hostage_skins_addskin <model> <soundpath>')

def adddownload():
    if int(es.getargc()) == 2:
        if os.path.exists(str(es.server_var['eventscripts_gamedir'])+'/'+str(es.getargv(1))):
            hostage_skins_downloadables.append(str(es.getargv(1)))
            es.stringtable('downloadables', str(es.getargv(1)))
        else:
            es.dbgmsg(0, 'Could not add downloadable '+str(es.getargv(1))+', file not found!')
    else:
        es.dbgmsg(0, 'Syntax: hostage_skins_adddownload <file>')
        
def _playsound(hostage, event):
    soundid = random.randint(0, len(hostage_skins_sounds[event])-1)
    soundname = hostage_skins_sounds[event][soundid]
    soundpath = hostage_skins_hostages[hostage]['soundpath']
    if len(soundpath) > 0:
        sound = str(soundpath)+'/'+str(soundname)
        if os.path.exists(str(es.server_var['eventscripts_gamedir'])+'/sound/'+sound):
            es.emitsound('entity', hostage, sound, 1.0, 1.0)

def _mdlstr(model):
    if model[:7] != 'models/':
        model = 'models/'+model
    if model[-4:] != '.mdl':
        model = model + '.mdl'
    return model
